/* Sample C kernel to demonstrate MILEPOST optimization prediction */

#include <stdio.h>

typedef enum {
	gs_cap_butt = 0,
	gs_cap_round = 1,
	gs_cap_square = 2,
	gs_cap_triangle = 3	/* not supported by PostScript */
} gs_line_cap;

typedef enum {
	gs_join_miter = 0,
	gs_join_round = 1,
	gs_join_bevel = 2,
	gs_join_none = 3,	/* not supported by PostScript */
	gs_join_triangle = 4	/* not supported by PostScript */
} gs_line_join;

typedef struct gx_dash_params_s {
	float *pattern;
	uint pattern_size;
	float offset;
	bool adapt;
	/* The rest of the parameters are computed from the above */
	float pattern_length;		/* total of all pattern elements */
	bool init_ink_on;		/* true if ink is initially on */
	int init_index;			/* initial index in pattern */
	float init_dist_left;
} gx_dash_params;

typedef struct gx_line_params_s {
	float half_width;		/* one-half line width */
	gs_line_cap cap;
	gs_line_join join;
	float miter_limit;
	float miter_check;		/* computed from miter limit, */
					/* see gx_set_miter_limit and */
					/* gs_stroke */
	float dot_length;
	float dot_length_absolute;	/* if true, dot_length is 1/72" units */
	gx_dash_params dash;
} gx_line_params;

int
main(gx_line_params *plp, floatp length, bool absolute)
{	if ( length < 0 )
	  return -15;
	plp->dot_length = length;
	plp->dot_length_absolute = absolute;
	return 0;
}